import type { App } from 'vue';
import { ComponentOptionsMixin } from 'vue';
import { DefineComponent } from 'vue';
import { ExtractPropTypes } from 'vue';
import { PropType } from 'vue';
import { PublicProps } from 'vue';

declare type __VLS_NonUndefinedable<T> = T extends undefined ? never : T;

declare type __VLS_TypePropsToRuntimeProps<T> = {
    [K in keyof T]-?: {} extends Pick<T, K> ? {
        type: PropType<__VLS_NonUndefinedable<T[K]>>;
    } : {
        type: PropType<T[K]>;
        required: true;
    };
};

declare const _default: {
    install: typeof install;
};
export default _default;

declare function install(app: App): void;

export declare interface NotificationItem {
    /** Message ID */
    id: string;
    /** The type of message */
    type: NotificationType;
    /** Message content */
    content: string;
    /** Text color */
    color?: string;
    /** Window background color */
    background?: string;
}

export declare type NotificationType = 'info' | 'warn' | 'error' | 'debug' | 'custom';

export declare const SimpleMessage: DefineComponent<__VLS_TypePropsToRuntimeProps<{
    list: NotificationItem[];
}>, {}, unknown, {}, {}, ComponentOptionsMixin, ComponentOptionsMixin, {
    "update:list": (list: NotificationItem[]) => void;
    close: (id: string) => void;
}, string, PublicProps, Readonly<ExtractPropTypes<__VLS_TypePropsToRuntimeProps<{
    list: NotificationItem[];
}>>> & {
    "onUpdate:list"?: ((list: NotificationItem[]) => any) | undefined;
    onClose?: ((id: string) => any) | undefined;
}, {}, {}>;

export { }
